/****************************************************************************
*
* Atmel Corporation
*
* ̧			: Touchscreen.h
* ߲		: IAR EWAAVR 4.20A
* 			: $Revision: 0.99 $
* t			: $Date: Thursday, September 20, 2006 $
* XV		: $Author: Jens Rotter $
*
* xҰ		: avr@atmel.com
*
* x޲	: ATmega88
*
* pLq		: ?
*
* 			: ڐGʐ 4(Low/Rtouch)5(Lowّ)
*
****************************************************************************/

#ifndef TOUCHSCREEN_H
#define TOUCHSCREEN_H

/****************************************************************************
  ײ
****************************************************************************/

#include <ioavr.h>
#include <inavr.h> 
#include "TWI_Master.h"
#include "usart.h"

/****************************************************************************
  ڐGʂƑ̌`
****************************************************************************/

// ݒ`(4:(Lowق܂Rtouch)||5:(Loŵّݗp\))

#define FOUR_WIRE
//#define LOW_LEVEL_MEASUREMENT
#define R_TOUCH_MEASUREMENT
//#define FIVE_WIRE

/****************************************************************************
  ֐`
****************************************************************************/

void                  Start_Measurement(void);
void                  Stop_Measurement(void);
void                  Store_valid_Data(void);
void                  ADC_Measurement(void);
void                  Insertion_Sort(short int Array[]);
extern void           Touchscreen_Init(void);

/****************************************************************************
  S̕ϐ
****************************************************************************/

typedef struct {
  unsigned char Flag_Register;
  short int x_pos;
  short int y_pos;
} Interface;
extern Interface Touchscreen_Data;

/****************************************************************************
  S̒`
****************************************************************************/

// Touchscreen_Data.Flag_Register̪pޯĒ`
#define FLAG_REGISTER_START						7
#define FLAG_REGISTER_SLEEP						6

#define FLAG_REGISTER_TOUCH						3
#define FLAG_REGISTER_END						2
#define FLAG_REGISTER_COORDINATES				1
#define FLAG_REGISTER_OVERFLOW					0

// ϸ
#define ClearBit(ADRESS,BIT)					(ADRESS&=~(1<<BIT))
#define SetBit(ADRESS,BIT)						(ADRESS|=(1<<BIT))
#define TestBit(ADRESS,BIT)						((ADRESS&(1<<BIT)))
#define ToogleBit(ADRESS, BIT)					((ADRESS) ^= (1 << (BIT)))

#define Pin_Pullup(Pin)							(SetBit(TOUCHSCREEN_OUTPUT, (Pin)), ClearBit(TOUCHSCREEN_DDR, (Pin)))
#define Pin_Vcc(Pin)							(SetBit(TOUCHSCREEN_OUTPUT, (Pin)), SetBit(TOUCHSCREEN_DDR, (Pin)))
#define Pin_Gnd(Pin)							(ClearBit(TOUCHSCREEN_OUTPUT, (Pin)), SetBit(TOUCHSCREEN_DDR, (Pin)))
#define Pin_Hi_Z(Pin)							(ClearBit(TOUCHSCREEN_DDR, (Pin)), ClearBit(TOUCHSCREEN_OUTPUT, (Pin)))

#define Check_Overflow(Flag)					if(TestBit(Touchscreen_Data.Flag_Register,(Flag))) SetBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_OVERFLOW)
#define STOP_TOUCHSCREEN						(TIMER0_CONTROL_REGISTER_B = (0 << TIMER0_CLOCK_SELECT), ClearBit(PIN_CHANGE_INTERRUPT_CONTROL_REGISTER, PIN_CHANGE_INTERRUPT_ENABLE_1), ADC_CONTROL_AND_STATUS_REGISTER_A  = 0)

// USARTݒ
#define USART_BAUD_RATE							19200
#define F_CPU									8000000
#define MY_UBRR									F_CPU/16/USART_BAUD_RATE-1

// /0ݒ (1msԊu)
#define TIMER0_INITIAL_VALUE_COMPARE_MATCH_A	124
#define TIMER0_INITIAL_VALUE_COMPARE_MATCH_B	80
#define TIMER0_PRESCALER						3		// =64
#define DEBOUNCE_TIME							8		// 8~1ms
#define SLEEP_COUNTDOWN							2000	// 2000~1ms ... SLEEP_COUNTDOWN !> 

// A/Dϊݒ
#define ADC_PRESCALER							6		// =64125kHz
#define START_CONVERSION						(SetBit(ADC_CONTROL_AND_STATUS_REGISTER_A, ADC_START_CONVERSION))

// ݒ
#define SAMPLES_FOR_ONE_TRUE_XY_PAIR			5		// 1̐^X/YWp̑
#define END_OF_ARRAY							SAMPLES_FOR_ONE_TRUE_XY_PAIR-1
#define MEDIAN									(SAMPLES_FOR_ONE_TRUE_XY_PAIR+1)/2	// l:SAMPLES_FOR_ONE_TRUE_XY_PAIR
#define MAXIMUM_LOW_LEVEL						300		// Low_Levelp > MAXIMUM_LOW_LEVEL
#define MAXIMUM_RTOUCH_LEVEL					2000	// R_Touchp   > MAXIMUM_RTOUCH_LEVEL
#define MAXIMUM_UNTOUCH_CONDITIONS				10		// ڐGȂԂ(AI)萔(10~1ms)

/****************************************************************************
  ޲ˑ`
****************************************************************************/

/****************************************************************************
  4
****************************************************************************/
#if defined FOUR_WIRE

// ڼ޽`

// o
#define TOUCHSCREEN_INPUT						PINC
#define TOUCHSCREEN_OUTPUT						PORTC
#define TOUCHSCREEN_DDR							DDRC
// ݕω
#define PIN_CHANGE_INTERRUPT_CONTROL_REGISTER	PCICR
#define PIN_CHANGE_INTERRUPT_FLAG_REGISTER		PCIFR
#define PIN_CHANGE_MASK_1_REGISTER				PCMSK1

// ޯĒ`

// o - 4
#define XP										0		// 
#define XN										1		// E
#define YP										2		// 㑤
#define YN										3		// 
#define ADC1									XN		// YWǂݎZ1ǂݎ
#define ADC2									YP		// Z2ǂݎ
#define STANDBY_PIN								YN		// ݕωLow_Level_ReadingsXWǂݎ

// ݕω
#define PIN_CHANGE_INTERRUPT_ENABLE_1			PCIE1
#define PIN_CHANGE_INTERRUPT_FLAG_1				PCIF1
#define PIN_CHANGE_ENABLE_MASK					PCINT11

// o͏
#define STANDBY_CONFIGURATION					(Pin_Gnd(XP), Pin_Hi_Z(XN), Pin_Hi_Z(YP), Pin_Pullup(YN))
#define X_POS_CONFIGURATION						(Pin_Gnd(XP), Pin_Vcc(XN), Pin_Hi_Z(YP), Pin_Hi_Z(YN))
#define Y_POS_CONFIGURATION						(Pin_Hi_Z(XP), Pin_Hi_Z(XN), Pin_Gnd(YP), Pin_Vcc(YN))
#define HI_Z_CONFIGURATION						(Pin_Hi_Z(XP), Pin_Hi_Z(XN), Pin_Hi_Z(YP), Pin_Hi_Z(YN))
#define Z_1_AND_2_CONFIGURATION					(Pin_Gnd(XP), Pin_Hi_Z(XN), Pin_Hi_Z(YP), Pin_Vcc(YN))

#endif

/****************************************************************************
  5
****************************************************************************/
#if defined FIVE_WIRE

// ڼ޽`

// o
#define TOUCHSCREEN_INPUT						PINC
#define TOUCHSCREEN_OUTPUT						PORTC
#define TOUCHSCREEN_DDR							DDRC
// ݕω
#define PIN_CHANGE_INTERRUPT_CONTROL_REGISTER	PCICR
#define PIN_CHANGE_INTERRUPT_FLAG_REGISTER		PCIFR
#define PIN_CHANGE_MASK_1_REGISTER				PCMSK1

// ޯĒ`

// o - 5wire
#define UL										0		// 
#define UR										1		// E
#define LL										2		// 
#define LR										3		// E
#define STANDBY_PIN								4		// ݕωƑSA/Dϊǂݎ
#define ADC1									STANDBY_PIN

// ݕω
#define PIN_CHANGE_INTERRUPT_ENABLE_1			PCIE1
#define PIN_CHANGE_INTERRUPT_FLAG_1				PCIF1
#define PIN_CHANGE_ENABLE_MASK					PCINT12

// o͏
#define STANDBY_CONFIGURATION					(Pin_Gnd(UL), Pin_Hi_Z(UR), Pin_Hi_Z(LL), Pin_Hi_Z(LR), Pin_Pullup(STANDBY_PIN))
#define X_POS_CONFIGURATION						(Pin_Gnd(UL), Pin_Vcc(UR), Pin_Gnd(LL), Pin_Vcc(LR), Pin_Hi_Z(STANDBY_PIN))
#define Y_POS_CONFIGURATION						(Pin_Gnd(UL), Pin_Gnd(UR), Pin_Vcc(LL), Pin_Vcc(LR), Pin_Hi_Z(STANDBY_PIN))
#define HI_Z_CONFIGURATION						(Pin_Hi_Z(UL), Pin_Hi_Z(UR), Pin_Hi_Z(LL), Pin_Hi_Z(LR), Pin_Hi_Z(STANDBY_PIN))

#endif

/****************************************************************************
  ʓI޲ˑ`
****************************************************************************/

// 荞޸`
#define PIN_CHANGE_VECTOR						PCINT1_vect
#define TIMER0_COMPARE_MATCH_A_VECTOR			TIMER0_COMPA_vect
#define TIMER0_COMPARE_MATCH_B_VECTOR			TIMER0_COMPB_vect
#define ADC_CONVERSION_COMPLETE_VECTOR			ADC_vect

// ڼ޽`
// /0
#define TIMER0_INTERRUPT_MASK_REGISTER			TIMSK0
#define TIMER0_INTERRUPT_FLAG_REGISTER			TIFR0
#define TIMER0_OUTPUT_COMPARE_REGISTER_A		OCR0A
#define TIMER0_OUTPUT_COMPARE_REGISTER_B		OCR0B
#define TIMER0_CONTROL_REGISTER_A				TCCR0A
#define TIMER0_CONTROL_REGISTER_B				TCCR0B

// A/Dϊ
#define ADC_CONTROL_AND_STATUS_REGISTER_A		ADCSRA
#define ADC_MULTIPLEXER_SELECTION_REGISTER		ADMUX

// ޯĒ`
// /0
#define TIMER0_CLOCK_SELECT						CS00
#define TIMER0_OUTPUT_COMPARE_A_INT_ENABLE		OCIE0A
#define TIMER0_OUTPUT_COMPARE_B_INT_ENABLE		OCIE0B
#define TIMER0_OUTPUT_COMPARE_B_MATCH_FLAG		OCF0B
#define TIMER0_WAVEFORM_GENERATION_MODE			WGM00

// A/Dϊ
#define ADC_ENABLE								ADEN
#define ADC_START_CONVERSION					ADSC
#define ADC_INTERRUPT_ENABLE					ADIE
#define ADC_PRESCALER_SELECT					ADPS0
#define ADC_REFERENCE_SELECTION					REFS0

#endif // TOUCHSCREEN_H
