/****************************************************************************
*
* Atmel Corporation
*
* ̧			: main.c
* ߲		: IAR EWAAVR 4.20A
* 			: $Revision: 0.99 $
* t			: $Date: Thursday, September 20, 2006 $
* XV		: $Author: Jens Rotter $
*
* xҰ		: avr@atmel.com
*
* x޲	: ATmega88
*
* pLq		: ?
*
* 			: ڐGʐ 4(Low/Rtouch)5(Lowّ)
*
****************************************************************************/

/****************************************************************************
  ײ
****************************************************************************/
#include "Touchscreen.h"

/****************************************************************************
  S̒`
****************************************************************************/
// ̪ݒ
#define UART_INTERFACE
//#define TWI_INTERFACE

#define FLAG_REGISTER_MASK	255		// ߂̂߂׸

#define STRING_BUFFER_SIZE	5		// ȂlASCIIւ̕ϊpɏՕ̗e

/****************************************************************************
  ֐`
****************************************************************************/
unsigned char Recognize_Event(void);
void Send_over_UART(void);
void Send_over_TWI(void);

/****************************************************************************
  S̕ϐ
****************************************************************************/
// ڐGʲ̪
extern Interface Touchscreen_Data;
Interface Buffer_Touchscreen_Data;

/****************************************************************************
  JԂ
****************************************************************************/
__C_task void main( void )
{
  USART_Init(MY_UBRR);			// USART
  TWI_Master_Initialise();		// TWI
  Touchscreen_Init();			// ڐGʏ
  __enable_interrupt();			// S̊荞݋

  for (;;)						// JԂ
  {
	if(Recognize_Event())
	{
	#if defined UART_INTERFACE
	  Send_over_UART();
	#endif
	#if defined TWI_INTERFACE
	  Send_over_TWI();
	#endif
	}
  }
}

unsigned char Recognize_Event(void)
{
  __disable_interrupt();

  Buffer_Touchscreen_Data = Touchscreen_Data;								// ްǂݍ
  Buffer_Touchscreen_Data.Flag_Register &= FLAG_REGISTER_MASK;				// Flag_RegisterՕ
  Touchscreen_Data.Flag_Register ^= Buffer_Touchscreen_Data.Flag_Register;	// ƈꗗ

  __enable_interrupt();
  return Buffer_Touchscreen_Data.Flag_Register;
}

void Send_over_UART(void)
{
  char String_Buffer[STRING_BUFFER_SIZE];		// ȂlASCIIɕϊ邽߂̊ɏՕ

  if(TestBit(Buffer_Touchscreen_Data.Flag_Register, FLAG_REGISTER_OVERFLOW))
  {
	uart_puts("Overflow ");						// :X/YW㏑܂B
  }
  else
  {
	if(TestBit(Buffer_Touchscreen_Data.Flag_Register, FLAG_REGISTER_START))
	{
	  uart_puts("Start... ");					// ۸ъJn˗Ⴆ΁Aʿĳ̂߂̍Z_W
	}

	if(TestBit(Buffer_Touchscreen_Data.Flag_Register, FLAG_REGISTER_SLEEP))
	{
	  uart_puts("Sleep ");						// sƂȂ˗Ⴆܰ޳

//	  SMCR = (2<<SM0)|(1<<SE);					// ܰ޳
//	  __sleep();
	}

	if(TestBit(Buffer_Touchscreen_Data.Flag_Register, FLAG_REGISTER_TOUCH))
	{
	  uart_puts("Touch ");						// ڐGm
	}

	if(TestBit(Buffer_Touchscreen_Data.Flag_Register, FLAG_REGISTER_END))
	{
	  uart_puts("End ");						// ڐGoI
	}

	if(TestBit(Buffer_Touchscreen_Data.Flag_Register, FLAG_REGISTER_COORDINATES))
	{
	  uart_puts(utoa(String_Buffer,STRING_BUFFER_SIZE,Buffer_Touchscreen_Data.x_pos));	// X/YW
	  uart_putc(' ');
	  uart_puts(utoa(String_Buffer,STRING_BUFFER_SIZE,Buffer_Touchscreen_Data.y_pos));
	  uart_putc(' ');
	}
  }
}

void Send_over_TWI(void)
{
  unsigned char TWI_messageBuf[6];												// TWIүޗpɏՕ

  if(Touchscreen_Data.Flag_Register!=0)											// ꂩ̎۔
  {

	TWI_messageBuf[0]  = (TWI_OWN_SLAVE_ADDRESS<<TWI_ADR_BITS) | (FALSE<<TWI_READ_BIT);
	TWI_messageBuf[1]  = (Touchscreen_Data.Flag_Register) | (TWI_CMD_MASTER_WRITE);

	if(TestBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_OVERFLOW)) 
	{
	  Touchscreen_Data.Flag_Register = 0;										// :X/YW㏑܂B
	}
	else
	{
	  if(TestBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_START))
	  {
		ClearBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_START);			// ۸ъJn˗Ⴆ΁Aʿĳ̂߂̍Z_W
	  }

	  if(TestBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_TOUCH))
	  {
		ClearBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_TOUCH);			// ڐGm
	  }

	  if(TestBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_END))
	  {
		ClearBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_END);			// ڐGoI
	  }

	  if(TestBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_COORDINATES))
	  {
		TWI_messageBuf[2] = (Touchscreen_Data.x_pos >> 8);						// X/YW
		TWI_messageBuf[3] =  Touchscreen_Data.x_pos;	
		TWI_messageBuf[4] = (Touchscreen_Data.y_pos >> 8);
		TWI_messageBuf[5] =  Touchscreen_Data.y_pos;

		ClearBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_COORDINATES);
	  }
	  if(TestBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_SLEEP))
	  {
		ClearBit(Touchscreen_Data.Flag_Register, FLAG_REGISTER_SLEEP);			// sƂȂ
	  }
	}
	TWI_Start_Transceiver_With_Data(TWI_messageBuf, 6);							// TWIүޑM
  }
}
