#include "Touchscreen.h"

/* MɏՕ̗e */
#define UART_RX_BUFFER_MASK ( UART_RX_BUFFER_SIZE - 1)
#define UART_TX_BUFFER_MASK ( UART_TX_BUFFER_SIZE - 1)

#if ( UART_RX_BUFFER_SIZE & UART_RX_BUFFER_MASK )
#error MɏՕ̑傫2ׂ̂ł͂܂B
#endif
#if ( UART_TX_BUFFER_SIZE & UART_TX_BUFFER_MASK )
#error MɏՕ̑傫2ׂ̂ł͂܂B
#endif

/* S̕ϐ */
static volatile unsigned char UART_TxBuf[UART_TX_BUFFER_SIZE];
static volatile unsigned char UART_RxBuf[UART_RX_BUFFER_SIZE];
static volatile unsigned char UART_TxHead;
static volatile unsigned char UART_TxTail;
static volatile unsigned char UART_RxHead;
static volatile unsigned char UART_RxTail;
static volatile unsigned char UART_LastRxError;

void USART_Init( unsigned int ubrr)
{
  UART_TxHead = 0;
  UART_TxTail = 0;
  UART_RxHead = 0;
  UART_RxTail = 0;

  /* ްڰĐݒ */
  UBRR0H = (unsigned char)(ubrr>>8);
  UBRR0L = (unsigned char)ubrr;
  /* MAMƂɑΉ銄荞݂ */
  UCSR0B = (1<<RXCIE0)|(1<<RXEN0)|(1<<TXEN0);
  /* ڰь`(8ޯ ްA1~ޯ)ݒ */
  UCSR0C = (1<<UCSZ00) | (1<<UCSZ01);
}

#pragma vector = USART_RX_vect
__interrupt void USART_RX_interrupt(void)
{
  unsigned char tmphead;
  unsigned char byte;
  unsigned char usr;
  unsigned char lastRxError;

  /* UARTڼ޽UARTް ڼ޽̓ǂݍ */
  usr  = UCSR0A;
  byte = UDR0;

  lastRxError = (usr & ((1<<FE0)|(1<<DOR0)|(1<<UPE0)));

  /* ɏՕwWvZ */
  tmphead = ( UART_RxHead + 1) & UART_RX_BUFFER_MASK;

  if ( tmphead == UART_RxTail )
  {
	/* ُ:MɏՕ */
	lastRxError = UART_BUFFER_OVERFLOW >> 8;
  }
  else
  {
	/* VwWi[ */
	UART_RxHead = tmphead;
	/* MްɏՕ֊i[ */
	UART_RxBuf[tmphead] = byte;
  }
  UART_LastRxError = lastRxError;
}

/*************************************************************************
֐	: uart_getc()
ړI	: ɏՕ޲ĂԂ܂B
߂l	: ޲ : ɏՕ̎M޲
          ޲ : Ō̎Mُ
**************************************************************************/
unsigned int uart_getc(void)
{
  unsigned char tmptail;
  unsigned char databyte;

  if ( UART_RxHead == UART_RxTail ) {
	return UART_NO_DATA;				/* p\ްȂ */
  }

  /* ɏՕwWvZ/i[ */
  tmptail = (UART_RxTail + 1) & UART_RX_BUFFER_MASK;
  UART_RxTail = tmptail; 

  /* MɏՕް擾 */
  databyte = UART_RxBuf[tmptail];

  return (UART_LastRxError << 8) + databyte;

} /* uart_getc */

/*************************************************************************
֐	: uart_putc()
ړI	: UARToRőM邽߂ɊɏՕ޲ď
	: Mׂ޲
߂l	: Ȃ
**************************************************************************/
void uart_putc(unsigned char byte)
{
  unsigned char tmphead;
  unsigned char tmptail;

  tmphead  = (UART_TxHead + 1) & UART_TX_BUFFER_MASK;

  while ( tmphead == UART_TxTail ){
	; /* ɏՕ󂫑҂ */
  }

  UART_TxBuf[tmphead] = byte;
  UART_TxHead = tmphead;

  /* USARTMɏՕ󂫑҂ */
  while ( !( UCSR0A & (1<<UDRE0)) );

  if ( (UART_TxHead) != (UART_TxTail)) 
  {
	/* VɏՕwWvZƊi[ */
	tmptail = (UART_TxTail + 1) & UART_TX_BUFFER_MASK;
	UART_TxTail = tmptail;

	/* ɏՕ1޲Ď擾ĂUART֏ */
	UDR0 = UART_TxBuf[tmptail];			/* USARTMJn */
  }
} /* uart_putc */

/*************************************************************************
֐	: uart_puts()
ړI	: UART֕񑗐M
	: Mׂ
߂l	: Ȃ
**************************************************************************/
void uart_puts(const char *s )
{
  while (*s) 
	uart_putc(*s++);
} /* uart_puts */

/*************************************************************************
֐	: utoa()
ړI	: Ȃasciiɕϊ
	: string_buffer, string_buffer_size, Ȃl
߂l	: 擪ascii
**************************************************************************/
char *utoa(char* buffer, const unsigned int size, unsigned int value)
{
  char *p;

  p = buffer+size-1;				// p͍Ō̕ւ̈ʒuwq
  *p='\0';							// Iq(0)ݒ
  do
  {
	*--p = value%10 + '0';
	value = value/10;
  } while (value!=0 && p>buffer);
  return p;
} /* utoa */
